// ---- Created with 3Dmigoto v1.3.16 on Wed Apr 24 21:53:08 2024
Texture2D<float4> t0 : register(t0);

SamplerState s0_s : register(s0);

cbuffer cb3 : register(b3)
{
  float4 cb3[25];
}

cbuffer cb2 : register(b2)
{
  float4 cb2[8];
}

cbuffer cb1 : register(b1)
{
  float4 cb1[7];
}

cbuffer cb0 : register(b0)
{
  float4 cb0[89];
}




// 3Dmigoto declarations
#define cmp -
Texture1D<float4> IniParams : register(t120);
Texture2D<float4> StereoParams : register(t125);
#define ini_inputs IniParams[87].xyz


void main(
  float4 v0 : POSITION0,
  float3 v1 : NORMAL0,
  float4 v2 : TANGENT0,
  float4 v3 : TEXCOORD0,
  float2 v4 : TEXCOORD1,
  float4 v5 : COLOR0,
  out float4 o0 : SV_POSITION0,
  out float4 o1 : COLOR0,
  out float4 o2 : TEXCOORD0,
  out float4 o3 : TEXCOORD1,
  out float4 o4 : TEXCOORD2,
  out float4 o5 : TEXCOORD3,
  out float2 o6 : TEXCOORD4)
{
  float4 r0,r1,r2,r3,r4;
  uint4 bitmask, uiDest;
  float4 fDest;

  o0 = float4(0.0,0.0,0.0,0.0);
  o1 = float4(0.0,0.0,0.0,0.0);
  o2 = float4(0.0,0.0,0.0,0.0);
  o3 = float4(0.0,0.0,0.0,0.0);
  o4 = float4(0.0,0.0,0.0,0.0);
  o5 = float4(0.0,0.0,0.0,0.0);
  o6 = float2(0.0,0.0);

  r0.x = cmp(0 != cb0[45].w);
  if (r0.x != 0) {
    r0.x = t0.SampleLevel(s0_s, cb0[47].xy, 0).x;
    r0.x = cmp(0.5 < r0.x);
    r0.x = r0.x ? 1.000000 : 0;
  } else {
    r0.y = cmp(0 != cb0[46].x);
    r0.x = r0.y ? 1.000000 : 0;
  }
  r0.y = cmp(0.5 < cb0[86].w);
  r0.x = r0.y ? 1 : r0.x;
  r0.yz = cmp(float2(0.5,0) < cb0[85].ww);
  r0.w = cmp(0.5 < cb0[37].w);
  r0.y = (int)r0.w | (int)r0.y;
  o6.x = r0.y ? 0 : r0.x;
  r0.yw = cmp(float2(0,0) != cb0[66].wx);
  r1.x = cmp(0 != cb0[67].x);
  r1.y = cmp(abs(cb0[68].w) < 0.00100000005);
  r2.xyz = cb0[68].xyz * cb0[68].www;
  r1.yzw = r1.yyy ? float3(0,0,0) : r2.xyz;
  r2.xyzw = cb2[5].xyzw * r1.zzzz;
  r2.xyzw = cb2[4].xyzw * r1.yyyy + r2.xyzw;
  r2.xyzw = cb2[6].xyzw * r1.wwww + r2.xyzw;
  r2.xyzw = cb2[7].xyzw + r2.xyzw;
  r1.yzw = r2.xyz / r2.www;
  r2.xyz = cb2[5].xyz * cb0[68].yyy;
  r2.xyz = cb2[4].xyz * cb0[68].xxx + r2.xyz;
  r2.xyz = cb2[6].xyz * cb0[68].zzz + r2.xyz;
  r1.y = dot(r1.yzw, r2.xyz);
  r1.z = dot(v0.xyz, r2.xyz);
  r1.w = cmp(r1.z < r1.y);
  r1.y = r1.z + -r1.y;
  r2.xyz = -r1.yyy * r2.xyz + v0.xyz;
  r2.w = 0;
  r3.xyz = v0.xyz;
  r3.w = v5.w;
  r2.xyzw = r1.wwww ? r2.xyzw : r3.xyzw;
  r1.y = dot(v0.xyz, cb0[68].xyz);
  r1.z = -0.00999999978 + cb0[68].w;
  r1.z = cmp(r1.y < r1.z);
  r1.y = -cb0[68].w + r1.y;
  r4.xyz = -r1.yyy * cb0[68].xyz + v0.xyz;
  r4.w = 0;
  r4.xyzw = r1.zzzz ? r4.xyzw : r3.xyzw;
  r1.xyzw = r1.xxxx ? r2.xyzw : r4.xyzw;
  r1.xyzw = r0.yyyy ? r1.xyzw : r3.xyzw;
  r2.xyw = cb2[3].xyz + -cb1[5].xyz;
  r3.x = cb2[0].x;
  r3.y = cb2[1].x;
  r3.z = cb2[2].x;
  r3.w = r2.x;
  r4.xyz = r1.xyz;
  r4.w = 1;
  r0.y = dot(r3.xyzw, r4.xyzw);
  r3.x = cb2[0].y;
  r3.y = cb2[1].y;
  r3.z = cb2[2].y;
  r3.w = r2.y;
  r1.x = dot(r3.xyzw, r4.xyzw);
  r2.x = cb2[0].z;
  r2.y = cb2[1].z;
  r2.z = cb2[2].z;
  r1.y = dot(r2.xyzw, r4.xyzw);
  r2.x = cb2[0].w;
  r2.y = cb2[1].w;
  r2.z = cb2[2].w;
  r2.w = cb2[3].w;
  r1.z = dot(r2.xyzw, r4.xyzw);
  r1.x+=ini_inputs.z;
  r2.xyzw = cb3[22].xyzw * r1.xxxx;
  r2.xyzw = cb3[21].xyzw * r0.yyyy + r2.xyzw;
  r2.xyzw = cb3[23].xyzw * r1.yyyy + r2.xyzw;
  r2.xyzw = cb3[24].xyzw * r1.zzzz + r2.xyzw;
  r0.y = cmp(cb0[66].y < 0.949999988);
  r0.y = r0.y ? r0.w : 0;
  r0.w = cb1[6].x * cb0[88].w;
  r1.x = cb0[88].z * r2.w;
  r1.y = r0.w * r2.w;
  r1.xy = r1.xy * float2(2,2) + r2.xy;
  r2.xy = r0.yy ? r1.xy : r2.xy;
  r3.xyzw = cb2[1].xyzw * r4.yyyy;
  r3.xyzw = cb2[0].xyzw * r4.xxxx + r3.xyzw;
  r3.xyzw = cb2[2].xyzw * r4.zzzz + r3.xyzw;
  r3.xyzw = cb2[3].xyzw * v0.wwww + r3.xyzw;
  r1.xyz = r3.xyz / r3.www;
  o5.xyz = cb1[5].xyz + -r1.xyz;
  v3.y += ini_inputs.y/8;
  v3.x += ini_inputs.x/16;
  o2.xy = v3.xy * cb0[26].xy + cb0[26].zw;
  o2.zw = v4.xy * cb0[26].xy + cb0[26].zw;
  r3.xyz = float3(0.5,0.5,0.5) * r2.xyw;
  r3.w = cb1[6].x * r3.y;
  o4.xy = r3.xw + r3.zz;
  r1.x = dot(v1.xyz, cb2[4].xyz);
  r1.y = dot(v1.xyz, cb2[5].xyz);
  r1.z = dot(v1.xyz, cb2[6].xyz);
  r0.y = dot(r1.xyz, r1.xyz);
  r0.y = rsqrt(r0.y);
  r1.xyz = r1.xyz * r0.yyy;
  r0.y = cmp(0 != r0.x);
  r3.xyz = r0.yyy ? cb0[86].xyz : cb0[85].xyz;
  r0.yzw = r0.zzz ? r3.xyz : cb0[81].xyz;
  r0.y = dot(r1.xyz, r0.yzw);
  o3.w = r0.y * 0.497500002 + 0.5;
  o0.xyzw = r2.xyzw;
  o1.xyz = v5.xyz;
  o1.w = r1.w;
  o3.xyz = r1.xyz;
  o4.zw = r2.zw;
  o6.y = r0.x;
  return;
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//
// Generated by Microsoft (R) D3D Shader Disassembler
//
//   using 3Dmigoto v1.3.16 on Wed Apr 24 21:53:08 2024
//
//
// Input signature:
//
// Name                 Index   Mask Register SysValue  Format   Used
// -------------------- ----- ------ -------- -------- ------- ------
// POSITION                 0   xyzw        0     NONE   float   xyzw
// NORMAL                   0   xyz         1     NONE   float   xyz
// TANGENT                  0   xyzw        2     NONE   float
// TEXCOORD                 0   xy          3     NONE   float   xy
// TEXCOORD                 1   xy          4     NONE   float   xy
// COLOR                    0   xyzw        5     NONE   float   xyzw
//
//
// Output signature:
//
// Name                 Index   Mask Register SysValue  Format   Used
// -------------------- ----- ------ -------- -------- ------- ------
// SV_POSITION              0   xyzw        0      POS   float   xyzw
// COLOR                    0   xyzw        1     NONE   float   xyzw
// TEXCOORD                 0   xyzw        2     NONE   float   xyzw
// TEXCOORD                 1   xyzw        3     NONE   float   xyzw
// TEXCOORD                 2   xyzw        4     NONE   float   xyzw
// TEXCOORD                 3   xyz         5     NONE   float   xyz
// TEXCOORD                 4   xy          6     NONE   float   xy
//
vs_5_0
dcl_globalFlags refactoringAllowed
dcl_constantbuffer CB0[89], immediateIndexed
dcl_constantbuffer CB1[7], immediateIndexed
dcl_constantbuffer CB2[8], immediateIndexed
dcl_constantbuffer CB3[25], immediateIndexed
dcl_sampler s0, mode_default
dcl_resource_texture2d (float,float,float,float) t0
dcl_input v0.xyzw
dcl_input v1.xyz
dcl_input v3.xy
dcl_input v4.xy
dcl_input v5.xyzw
dcl_output_siv o0.xyzw, position
dcl_output o1.xyzw
dcl_output o2.xyzw
dcl_output o3.xyzw
dcl_output o4.xyzw
dcl_output o5.xyz
dcl_output o6.xy
dcl_temps 5
ne r0.x, l(0.000000, 0.000000, 0.000000, 0.000000), cb0[45].w
if_nz r0.x
  sample_l_indexable(texture2d)(float,float,float,float) r0.x, cb0[47].xyxx, t0.xyzw, s0, l(0.000000)
  lt r0.x, l(0.500000), r0.x
  and r0.x, r0.x, l(0x3f800000)
else
  ne r0.y, l(0.000000, 0.000000, 0.000000, 0.000000), cb0[46].x
  and r0.x, r0.y, l(0x3f800000)
endif
lt r0.y, l(0.500000), cb0[86].w
movc r0.x, r0.y, l(1.000000), r0.x
lt r0.yz, l(0.000000, 0.500000, 0.000000, 0.000000), cb0[85].wwww
lt r0.w, l(0.500000), cb0[37].w
or r0.y, r0.w, r0.y
movc o6.x, r0.y, l(0), r0.x
ne r0.yw, l(0.000000, 0.000000, 0.000000, 0.000000), cb0[66].wwwx
ne r1.x, l(0.000000, 0.000000, 0.000000, 0.000000), cb0[67].x
lt r1.y, |cb0[68].w|, l(0.001000)
mul r2.xyz, cb0[68].wwww, cb0[68].xyzx
movc r1.yzw, r1.yyyy, l(0,0,0,0), r2.xxyz
mul r2.xyzw, r1.zzzz, cb2[5].xyzw
mad r2.xyzw, cb2[4].xyzw, r1.yyyy, r2.xyzw
mad r2.xyzw, cb2[6].xyzw, r1.wwww, r2.xyzw
add r2.xyzw, r2.xyzw, cb2[7].xyzw
div r1.yzw, r2.xxyz, r2.wwww
mul r2.xyz, cb0[68].yyyy, cb2[5].xyzx
mad r2.xyz, cb2[4].xyzx, cb0[68].xxxx, r2.xyzx
mad r2.xyz, cb2[6].xyzx, cb0[68].zzzz, r2.xyzx
dp3 r1.y, r1.yzwy, r2.xyzx
dp3 r1.z, v0.xyzx, r2.xyzx
lt r1.w, r1.z, r1.y
add r1.y, -r1.y, r1.z
mad r2.xyz, -r1.yyyy, r2.xyzx, v0.xyzx
mov r2.w, l(0)
mov r3.xyz, v0.xyzx
mov r3.w, v5.w
movc r2.xyzw, r1.wwww, r2.xyzw, r3.xyzw
dp3 r1.y, v0.xyzx, cb0[68].xyzx
add r1.z, cb0[68].w, l(-0.010000)
lt r1.z, r1.y, r1.z
add r1.y, r1.y, -cb0[68].w
mad r4.xyz, -r1.yyyy, cb0[68].xyzx, v0.xyzx
mov r4.w, l(0)
movc r4.xyzw, r1.zzzz, r4.xyzw, r3.xyzw
movc r1.xyzw, r1.xxxx, r2.xyzw, r4.xyzw
movc r1.xyzw, r0.yyyy, r1.xyzw, r3.xyzw
add r2.xyw, -cb1[5].xyxz, cb2[3].xyxz
mov r3.x, cb2[0].x
mov r3.y, cb2[1].x
mov r3.z, cb2[2].x
mov r3.w, r2.x
mov r4.xyz, r1.xyzx
mov r4.w, l(1.000000)
dp4 r0.y, r3.xyzw, r4.xyzw
mov r3.x, cb2[0].y
mov r3.y, cb2[1].y
mov r3.z, cb2[2].y
mov r3.w, r2.y
dp4 r1.x, r3.xyzw, r4.xyzw
mov r2.x, cb2[0].z
mov r2.y, cb2[1].z
mov r2.z, cb2[2].z
dp4 r1.y, r2.xyzw, r4.xyzw
mov r2.x, cb2[0].w
mov r2.y, cb2[1].w
mov r2.z, cb2[2].w
mov r2.w, cb2[3].w
dp4 r1.z, r2.xyzw, r4.xyzw
mul r2.xyzw, r1.xxxx, cb3[22].xyzw
mad r2.xyzw, cb3[21].xyzw, r0.yyyy, r2.xyzw
mad r2.xyzw, cb3[23].xyzw, r1.yyyy, r2.xyzw
mad r2.xyzw, cb3[24].xyzw, r1.zzzz, r2.xyzw
lt r0.y, cb0[66].y, l(0.950000)
and r0.y, r0.y, r0.w
mul r0.w, cb0[88].w, cb1[6].x
mul r1.x, r2.w, cb0[88].z
mul r1.y, r2.w, r0.w
mad r1.xy, r1.xyxx, l(2.000000, 2.000000, 0.000000, 0.000000), r2.xyxx
movc r2.xy, r0.yyyy, r1.xyxx, r2.xyxx
mul r3.xyzw, r4.yyyy, cb2[1].xyzw
mad r3.xyzw, cb2[0].xyzw, r4.xxxx, r3.xyzw
mad r3.xyzw, cb2[2].xyzw, r4.zzzz, r3.xyzw
mad r3.xyzw, cb2[3].xyzw, v0.wwww, r3.xyzw
div r1.xyz, r3.xyzx, r3.wwww
add o5.xyz, -r1.xyzx, cb1[5].xyzx
mad o2.xy, v3.xyxx, cb0[26].xyxx, cb0[26].zwzz
mad o2.zw, v4.xxxy, cb0[26].xxxy, cb0[26].zzzw
mul r3.xyz, r2.xywx, l(0.500000, 0.500000, 0.500000, 0.000000)
mul r3.w, r3.y, cb1[6].x
add o4.xy, r3.zzzz, r3.xwxx
dp3 r1.x, v1.xyzx, cb2[4].xyzx
dp3 r1.y, v1.xyzx, cb2[5].xyzx
dp3 r1.z, v1.xyzx, cb2[6].xyzx
dp3 r0.y, r1.xyzx, r1.xyzx
rsq r0.y, r0.y
mul r1.xyz, r0.yyyy, r1.xyzx
ne r0.y, l(0.000000, 0.000000, 0.000000, 0.000000), r0.x
movc r3.xyz, r0.yyyy, cb0[86].xyzx, cb0[85].xyzx
movc r0.yzw, r0.zzzz, r3.xxyz, cb0[81].xxyz
dp3 r0.y, r1.xyzx, r0.yzwy
mad o3.w, r0.y, l(0.497500), l(0.500000)
mov o0.xyzw, r2.xyzw
mov o1.xyz, v5.xyzx
mov o1.w, r1.w
mov o3.xyz, r1.xyzx
mov o4.zw, r2.zzzw
mov o6.y, r0.x
ret
// Approximately 0 instruction slots used

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
